routes/web.php
<?php

use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\GradeController;
use App\Http\Controllers\NewsController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [NewsController::class, 'index']);

Route::resource('users', UserController::class);
Route::resource('news', NewsController::class);
Route::resource('tags', TagController::class);
Route::resource('categories', CategoryController::class);
Route::resource('grades', GradeController::class);
Route::resource('comments', CommentController::class);


Auth::routes();

app/Models/News.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @method static paginate(int $int)
 */
class News extends Model
{
    use HasFactory;
    protected $fillable = ['name', 'text', 'publication_date', 'user_id', 'category_id', 'tag_id'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class);
    }


    /**
     * @return HasMany
     */
    public function grades(): HasMany
    {
        return $this->hasMany(Grade::class);
    }
}

app/Http/Controllers/NewsController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\News;
use App\Models\Tag;
use Carbon\Carbon;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class NewsController extends Controller
{

    /**
     * @param Request $request
     * @return Application|Factory|View
     */
    public function index(Request $request)
    {
        $newsQuery = News::query();

        if ($request->input('category_id')){
            $newsQuery->where('category_id', $request->category_id);
        }
        if ($request->input('tag_id')){
            $newsQuery->where('tag_id',  $request->tag_id);
        }

        $news = $newsQuery
            ->where('publication_date', '!=', null )
            ->where('publication_date', '<=', Carbon::today())->paginate(4);

        $categories = Category::all();
        $tags = Tag::all();
        return view('news.index', compact('news', 'categories', 'tags'));
    }


    /**
     * @return Application|Factory|View
     */
    public function create()
    {
        $categories = Category::all();
        $tags = Tag::all();
        return view('news.create', compact('categories', 'tags'));
    }


    /**
     * @param Request $request
     * @return RedirectResponse
     */
    public function store(Request $request): RedirectResponse
    {
        $news = new News($request->all());
        $news->save();
        return redirect()->route('news.index')->with('successfully created');
    }


    /**
     * @param News $news
     * @return Application|Factory|View
     */
    public function show(News $news)
    {
        return view('news.show', compact('news'));
    }


    /**
     * @param News $news
     * @return Application|Factory|View
     */
    public function edit(News $news)
    {
        $categories = Category::all();
        $tags = Tag::all();
        return view('news.edit', compact('news', 'categories', 'tags'));
    }


    /**
     * @param Request $request
     * @param News $news
     * @return RedirectResponse
     */
    public function update(Request $request, News $news): RedirectResponse
    {
        $news->update($request->all());
        return redirect()->route('news.index')->with('successfully updated');
    }


    /**
     * @param News $news
     * @return RedirectResponse
     */
    public function destroy(News $news): RedirectResponse
    {
        $news->delete();
        return redirect()->route('news.index')->with('successfully deleted');
    }
}

resources/views/news/create.blade.php
@extends('layouts.app')

@section('content')
    <h2 class="text-center">Создайте новость</h2>
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <form action="{{route('news.store')}}" method="post">
                    @csrf

                    <input type="hidden" name="user_id" value="{{\Illuminate\Support\Facades\Auth::user()->getAuthIdentifier()}}">

                    <div class="form-group row">
                        <label for="institution_id" class="col-md-4 col-form-label text-md-right">Категория</label>
                        <div class="col-md-6">
                            <select class="custom-select" name="category_id">
                                @foreach($categories as $category)
                                    <option value="{{$category->id}}">{{$category->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>


                    <div class="form-group row">
                        <label for="institution_id" class="col-md-4 col-form-label text-md-right">Тэг</label>
                        <div class="col-md-6">
                            <select class="custom-select" name="tag_id">
                                @foreach($tags as $tag)
                                    <option value="{{$tag->id}}">{{$tag->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>


                    <div class="form-group row">
                        <label for="user_id" class="col-md-4 col-form-label text-md-right">Название</label>
                        <div class="col-md-6">
                            <input type="text" name="name" >
                            @error('name')
                            <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                            @enderror
                        </div>
                    </div>


                    <div class="form-group row">
                        <label for="text"
                               class="col-md-4 col-form-label text-md-right">Содержимое</label>

                        <div class="col-md-6">
                                    <textarea class="form-control @error('text') is-invalid @enderror" id="text"
                                              rows="3" name="text">{{ old('text') }}</textarea>
                            @error('text')
                            <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                            @enderror
                        </div>
                    </div>


                    <div class="form-group row mb-0">
                        <div class="col-md-6 offset-md-6">
                            <button type="submit" class="btn btn-primary">
                               Сохранить
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/news/edit.blade.php
@extends('layouts.app')

@section('content')
    <h2 class="text-center">Изменить новость</h2>
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <form action="{{route('news.update', ['news' => $news])}}" method="post">
                    @csrf
                    @method('PUT')
                    <input type="hidden" name="user_id" value="{{\Illuminate\Support\Facades\Auth::user()->getAuthIdentifier()}}">

                    <div class="form-group row">
                        <label for="institution_id" class="col-md-2 col-form-label text-md-right">Категория</label>
                        <div class="col-md-6">
                            <select class="custom-select" name="category_id">
                                @foreach($categories as $category)
                                    <option value="{{$category->id}}">{{$category->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>


                    <div class="form-group row">
                        <label for="institution_id" class="col-md-2 col-form-label text-md-right">Тэг</label>
                        <div class="col-md-6">
                            <select class="custom-select" name="tag_id">
                                @foreach($tags as $tag)
                                    <option value="{{$tag->id}}">{{$tag->name}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>


                    <div class="form-group row">
                        <label for="user_id" class="col-md-2 col-form-label text-md-right">Название</label>
                        <div class="col-md-6">
                            <input type="text" name="name" class="w-100" value="{{$news->name}}" >
                            @error('name')
                            <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                            @enderror
                        </div>
                    </div>


                    <div class="form-group row">
                        <label for="text"
                               class="col-md-2 col-form-label text-md-right">Содержимое</label>

                        <div class="col-md-6">
                                    <textarea class="form-control @error('text') is-invalid @enderror" id="text"
                                              rows="15"  name="text">{{$news->text}}</textarea>
                            @error('text')
                            <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                            @enderror
                        </div>
                    </div>


                    <div class="form-group row mb-0">
                        <div class="col-md-6 offset-md-6">
                            <button type="submit" class="btn btn-primary">
                                Изменить
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/news/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col">
            <h1 class="text-center">Последние Новости</h1>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <a class="btn btn-outline-primary" href="{{route('news.create')}}">Добавить новость</a>
            <div class="form">
                <form action="{{route('news.index')}}" class="float-end" method="GET">
                    <lable>Категории</lable>
                    <select name="category_id" class="custom-select">
                        <option value="{{null}}" selected>Все...</option>
                        @foreach($categories as $category)
                            <option value="{{$category->id}}" >{{$category->name}}</option>
                        @endforeach
                    </select>
                    <lable>Тэги</lable>
                    <select  name="tag_id" class="custom-select">
                        <option value="{{null}}" selected>Все...</option>
                        @foreach($tags as $tag)
                            <option value="{{$tag->id}}" >{{$tag->name}}</option>
                        @endforeach
                    </select>
                    <button class="btn btn-outline-primary">
                        фильтр
                    </button>
                </form>
            </div>
        </div>
    </div>
    <hr>
    <div class="row">
        <div class="col" >
            @foreach($news as $new)
                <form action="{{route('news.destroy', ['news' => $new])}}" method="post">
                    @csrf
                    @method('delete')
                    <button class="float-end btn btn-outline-danger">Удалить</button>
                </form>
                <div class="index mb-5 pb-5">
                <div class="text-center">
                    <h2><a class="text-decoration-none" href="{{route('news.show', ['news' => $new])}}">{{$new->name}}</a></h2>
                    <h4>автор: {{$new->user->name}}</h4>
                   <p>{{$new->text}}</p><br>
                </div>
                </div>
            @endforeach
        </div>
    </div>
    <div class="row">
        <div class="col">
            {{$news->links('pagination::bootstrap-4')}}
        </div>
    </div>
@endsection

resources/views/news/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col">
            <a class="btn btn-outline-primary" href="{{route('news.edit', compact('news'))}}">Изменить</a>
            <div class="index mb-5 pb-5">
                <div class="text-center">
                    <h2>{{$news->name}}</h2>
                    <h4>автор: {{$news->user->name}}</h4>
                    <p>{{$news->text}}</p><br>
                    <p class="float-lg-start">дата создание {{$news->created_at}}</p>
                    <p class="float-end">дата публикации {{$news->publication_date}}</p>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <h2>Комментарии</h2>
            <form action="{{route('comments.store')}}" method="post">
                @csrf
                <input type="hidden" name="news_id" value="{{$news->id}}">
                <div class="form-group row">
                    <div class="col-md-12">
                                    <textarea class="form-control @error('text') is-invalid @enderror" id="text"
                                              rows="3" name="text">{{ old('text') }}</textarea>
                        @error('text')
                        <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                        @enderror
                    </div>
                </div>
                <button class="btn btn-outline-primary">добавить комментарии</button>
            </form>
            @foreach($news->comments as $comment)
                @if($comment->verified == true)
                    <p>Автор: {{$comment->user->name}}<br>"{{$comment->text}}"</p>
                    <form action="{{action([\App\Http\Controllers\CommentController::class, 'destroy'], ['comment' => $comment])}}" method="post">
                        @csrf
                        @method('delete')
                        <button class="btn btn-outline-danger">удалить</button>
                    </form>
                @endif
                    <br>
            @endforeach
        </div>
    </div>

    <div class="row">
        <div class="col">
            <h2>Оценить</h2>

            <form action="{{action([\App\Http\Controllers\GradeController::class, 'store'])}}" method="post">
                @csrf
                <input type="hidden" name="user_id" value="{{\Illuminate\Support\Facades\Auth::user()->getAuthIdentifier()}}">
                <input type="hidden" name="news_id" value="{{$news->id}}">
                <select class="custom-select" name="qualitatively">
                    <option value="{{1}}">качественно</option>
                    <option value="{{-1}}">не качественно</option>
                </select>
                <select class="custom-select" name="actual">
                    <option value="{{1}}">актуально</option>
                    <option value="{{-1}}">не актуально</option>
                </select>
                <select class="custom-select" name="satisfied">
                    <option value="{{1}}">довольный</option>
                    <option value="{{-1}}">не довольный</option>
                </select>
                <button class="btn btn-outline-primary">оценить</button>
            </form>

            @foreach($news->grades as $grade)
                <form action="{{action([\App\Http\Controllers\GradeController::class, 'update'], ['grade' => $grade])}}" method="post">
                    @csrf
                    @method('PUT')
                    <input type="hidden" name="user_id" value="{{\Illuminate\Support\Facades\Auth::user()->getAuthIdentifier()}}">
                    <input type="hidden" name="news_id" value="{{$news->id}}">
                    <select class="custom-select" name="qualitatively">
                        <option value="{{1}}">качественно</option>
                        <option value="{{-1}}">не качественно</option>
                    </select>
                    <select class="custom-select" name="actual">
                        <option value="{{1}}">актуально</option>
                        <option value="{{-1}}">не актуально</option>
                    </select>
                    <select class="custom-select" name="satisfied">
                        <option value="{{1}}">довольный</option>
                        <option value="{{-1}}">не довольный</option>
                    </select>
                    <button class="btn btn-outline-primary">изменить оценку</button>
                </form>

                    <h5>автор: {{$grade->user->name}}</h5>
                    <li> @if($grade->qualitatively == 1) качественно @elseif($grade->qualitatively == -1) не качественно @endif</li>
                    <li> @if($grade->actual == 1) актуально @elseif($grade->actual == -1) не актуально @endif</li>
                    <li> @if($grade->satisfied == 1) довольный @elseif($grade->satisfied == -1) не довольный @endif</li>
                    <form action="{{action([\App\Http\Controllers\GradeController::class, 'destroy'], ['grade' => $grade])}}" method="post">
                        @csrf
                        @method('delete')
                        <button class="btn btn-outline-danger">
                            удалить
                        </button>
                    </form>
                    <br><br>
                @endforeach
            </div>
        </div>

@endsection